<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      procart Enterprise 3.8                                       ***
  ***      File:  admin_table_items.php                                    ***
  ***      Built: Tue Nov 14 19:00:40 2006                                 ***
  ***      http://www.procart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	$table_name = $table_prefix . "items";
	$table_alias = "i";
	$table_pk = "item_id";
	$table_title = "Products";
	$min_column_allowed = 1;

	$db_columns = array(
		"item_id" => array("Product ID", INTEGER, 1, false),
		"user_id" => array("User ID", INTEGER, 2, true, 0),
		"is_showing" => array("Available for Sales", INTEGER, 2, true, 1),
		"is_approved" => array("Is Approved", INTEGER, 2, true, 1),
		"item_name" => array("Product Name", TEXT, 2, false),
		"friendly_url" => array("Friendly URL", TEXT, 2, false, ""),
		"item_order" => array("Product Order", INTEGER, 2, true, 1),
		"item_type_id" => array("Product Type", INTEGER, 3, true, 1),
		"property_name" => array("Product Option", TEXT, 5, false, $table_prefix . "items_properties"),
		"category_name" => array("Category", TEXT, 5, false, $table_prefix . "categories"),
		"manufacturer_id" => array("Manufacturer ID", INTEGER, 3, false),
		"manufacturer_code" => array("Manufacturer Code", TEXT, 2, false),
		"manufacturer_name" => array("Manufacturer Name", TEXT, 5, false, $table_prefix . "manufacturers"),
		"weight" => array("Weight", FLOAT, 2, false),
		"issue_date" => array("Issue Date", DATE, 2, false),
		"tax_free" => array("Tax Free", INTEGER, 2, false),
		"language_code" => array("Language", TEXT, 2, false),
		"price" => array("Price", FLOAT, 2, true, 0),
		"is_price_edit" => array("Is Price Edit", INTEGER, 2, true, 0),
		"properties_price" => array("Options Price", FLOAT, 2, true, 0),
		"is_sales" => array("Is Discount Active", INTEGER, 2, true, 0),
		"sales_price" => array("Discount Price", FLOAT, 2, true, 0),
		"trade_price" => array("Trade Price", FLOAT, 2, true, 0),
		"trade_sales" => array("Discount Trade Price", FLOAT, 2, true, 0),
		"discount_percent" => array("Discount Percent", FLOAT, 2, false),
		"buying_price" => array("Buying Price", FLOAT, 2, false),
		"merchant_fee_type" => array("Merchant Fee Type", INTEGER, 2, false),
		"merchant_fee_amount" => array("Merchant Fee Amount", FLOAT, 2, false),
		"affiliate_commission_type" => array("Affiliate Commission Type", INTEGER, 2, false),
		"affiliate_commission_amount" => array("affiliate Commission Amount", FLOAT, 2, false),
		"short_description" => array("Short Description", TEXT, 2, false),
		"features" => array("Features", TEXT, 2, false),
		"full_desc_type" => array("Full Description Type", INTEGER, 2, false),
		"full_description" => array("Full Description", TEXT, 2, false),
		"specification" => array("Specification", TEXT, 2, false),
		"is_special_offer" => array("Is Special Offer", INTEGER, 2, true, 0),
		"special_offer" => array("Special Offer", TEXT, 2, false),
		"small_image" => array("Small Image", TEXT, 2, false),
		"big_image" => array("Big Image", TEXT, 2, false),
		"super_image" => array("Super-Sized Image", TEXT, 2, false),
		"use_stock_level" => array("Use Stock Level", INTEGER, 2, true, 1),
		"stock_level" => array("Stock Level", INTEGER, 2, false),
		"hide_out_of_stock" => array("Hide Off Limits Products", INTEGER, 2, true, 0),
		"disable_out_of_stock" => array("Disable Off Limits Products", INTEGER, 2, true, 0),
		"downloadable" => array("Is Downloadable", INTEGER, 2, false),
		"download_period" => array("Download Period", INTEGER, 2, false),
		"download_path" => array("Download Path", TEXT, 2, false),
		"shipping_in_stock" => array("In Stock Availability", INTEGER, 2, false),
		"shipping_out_stock" => array("Out of Stock Availability", INTEGER, 2, false),
		"shipping_rule_id" => array("Shipping Restrictions", INTEGER, 2, false),
		"shipping_cost" => array("Shipping Cost", FLOAT, 2, false),
		"votes" => array("Total Votes", INTEGER, 2, false),
		"points" => array("Total Points", INTEGER, 2, false),
		"rating" => array("Rating", FLOAT, 2, false),
		"notes" => array("Notes", TEXT, 2, false),
		"buy_link" => array("Direct Buy Link", TEXT, 2, false),
	);

	$db_aliases["id"] = "item_id";
	$db_aliases["product_id"] = "item_id";
	$db_aliases["item id"] = "item_id";
	$db_aliases["title"] = "item_name";
	$db_aliases["item"] = "item_name";
	$db_aliases["product"] = "item_name";
	$db_aliases["product title"] = "item_name";
	$db_aliases["product name"] = "item_name";
	$db_aliases["item title"] = "item_name";
	$db_aliases["item name"] = "item_name";
	$db_aliases["product_title"] = "item_name";
	$db_aliases["product_name"] = "item_name";
	$db_aliases["item_title"] = "item_name";
	$db_aliases["code"] = "manufacturer_code";
	$db_aliases["product shown"] = "is_showing";
	$db_aliases["product_shown"] = "is_showing";
	$db_aliases["item shown"] = "is_showing";
	$db_aliases["item_shown"] = "is_showing";
	$db_aliases["is show"] = "is_showing";
	$db_aliases["is shown"] = "is_showing";
	$db_aliases["is showning"] = "is_showing";
	$db_aliases["is_show"] = "is_showing";
	$db_aliases["is_shown"] = "is_showing";
	$db_aliases["is_showning"] = "is_showing";
	$db_aliases["item order"] = "item_order";
	$db_aliases["product_order"] = "item_order";
	$db_aliases["type"] = "item_type_id";
	$db_aliases["item_type"] = "item_type_id";
	$db_aliases["item type"] = "item_type_id";
	$db_aliases["quantity"] = "stock_level";

?>